apiVersion: tekton.dev/v1beta1
kind: Task
metadata:
  labels:
    {{ network_policy_deployment_label }}: job-{{ tekton_name }}
    version: "{{ tekton_assets_version }}"
  name: k8s-deploy
  namespace: {{ buildns }}
spec:
  params:
  - name: action
    description: Kubernetes Verb
    type: string
    default: create
  - name: assets
    description: Kubernetes Object(s)
    type: string
    default: deploy/demo.yaml
  - name: identifier
    description: Kubernetes resources Identifier
    type: string
    default: demo
  - name: namespace
    description: Kubernetes Namespace
    type: string
    default: demo-ci
  - name: image
    default: {{ tekton_k8s_client_image }}
    description: Kubectl wrapper image
  - name: appimage
    description: Image to Deploy
    type: string
  steps:
  - args:
    - -c
    - |
        SECRET_DIR=/run/secrets/kubernetes.io/serviceaccount
        K8S_TOKEN=`cat "$SECRET_DIR/token" 2>/dev/null`
        if ! test "$K8S_TOKEN"; then
            echo Could not resolve Kubernetes Bearer Token
            exit 1
        fi

        K8S_CMD="kubectl --token=$K8S_TOKEN --insecure-skip-tls-verify"
        if ! $K8S_CMD describe ns $(params.namespace) >/dev/null 2>&1; then
            if ! $K8S_CMD create ns $(params.namespace); then
                echo failed creating namespace $(params.namespace)
                exit 1
            fi
        fi

        for f in $(params.assets);
        do
            if test -s $f; then
                sed -i \
                    -e 's|IMAGE_PLACEHOLDER|$(params.appimage)|g' \
                    -e 's|NAME_PLACEHOLDER|$(params.identifier)|g' $f
            fi
            if ! $K8S_CMD $(params.action) -f $f; then
                echo failed to $(params.action) objects from $f
                exit 1
            fi
        done

        echo DONE

        exit 0
    command:
    - /bin/sh
    image: $(params.image)
    name: kubectl
{% if tekton_uses_resources_limits | default(False) %}
    resources:
      limits:
        cpu: "{{ tekton_k8s_client_cpu_limit }}"
        memory: {{ tekton_k8s_client_memory_limit }}
      requests:
        cpu: "{{ tekton_k8s_client_cpu_request }}"
        memory: {{ tekton_k8s_client_memory_request }}
{% else %}
    resources: {}
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
    securityContext:
      runAsUser: {{ k8s_unprivileged_userid }}
{% endif %}
    workingDir: "$(workspaces.source.path)"
  workspaces:
  - name: source
